package com.blogspot.lucbors.view.utils;

import oracle.adf.model.binding.DCIteratorBinding;
import oracle.adf.view.rich.component.rich.data.RichTable;
import oracle.jbo.Key;
import oracle.jbo.uicli.binding.JUCtrlHierBinding;
import oracle.jbo.uicli.binding.JUCtrlHierNodeBinding;
import org.apache.myfaces.trinidad.event.SelectionEvent;
import org.apache.myfaces.trinidad.model.CollectionModel;

public class GenericTableSelectionHandler {
    public GenericTableSelectionHandler() {
        super();
    }
   
    /**
     * Synchronizes the table UI component row selection with the selection in
     * the ADF binding layer
     * @param selectionEvent event object created by the table component upon row
     * selection
     */
    public static void makeCurrent(SelectionEvent selectionEvent){       
       
        RichTable _table = (RichTable) selectionEvent.getSource();
        CollectionModel   _tableModel = (CollectionModel) _table.getValue();
        JUCtrlHierBinding _adfTableBinding = (JUCtrlHierBinding) _tableModel.getWrappedData();
        DCIteratorBinding _tableIteratorBinding = _adfTableBinding.getDCIteratorBinding();
        Object _selectedRowData = _table.getSelectedRowData();
        JUCtrlHierNodeBinding _nodeBinding = (JUCtrlHierNodeBinding) _selectedRowData;
        //get the row key from the node binding and set it as the current row in the
        //iterator
        Key _rwKey = _nodeBinding.getRowKey();
        _tableIteratorBinding.setCurrentRowWithKey(_rwKey.toStringFormat(true));       
    }
}
